diff -rNbu binutils_060913_org/ld/pe-dll.c binutils_060913/ld/pe-dll.c
--- binutils_060913_org/ld/pe-dll.c	2006-08-21 10:12:46.000000000 +0200
+++ binutils_060913/ld/pe-dll.c	2006-09-11 18:04:18.000000000 +0200
@@ -40,7 +40,27 @@
 #include "coff/internal.h"
 #include "../bfd/libcoff.h"
 #include "deffile.h"
+
+#ifdef pe_use_x86_64
+#define PE_IDATA4_SIZE	8
+#define PE_IDATA5_SIZE	8
+
+#include "pep-dll.h"
+
+#undef AOUTSZ
+#define AOUTSZ		PEPAOUTSZ
+#define PEAOUTHDR	PEPAOUTHDR
+#else
 #include "pe-dll.h"
+#endif
+
+#ifndef PE_IDATA4_SIZE
+#define PE_IDATA4_SIZE	4
+#endif
+
+#ifndef PE_IDATA4_SIZE
+#define PE_IDATA4_SIZE	4
+#endif
 
 /*  This file turns a regular Windows PE image into a DLL.  Because of
     the complexity of this operation, it has been broken down into a
@@ -49,7 +69,7 @@
     normally only called once, so static variables are used to reduce
     the number of parameters and return values required.
 
-    See also: ld/emultempl/pe.em.  */
+    See also: ld/emultempl/pe.em and ld/emultempl/pep.em.  */
 
 /*  Auto-import feature by Paul Sokolovsky
 
@@ -144,14 +164,14 @@
 static int runtime_pseudo_relocs_created = 0;
 
 typedef struct
-{
+  {
   char *name;
   int len;
-}
+  }
 autofilter_entry_type;
 
 typedef struct
-{
+  {
   char *target_name;
   char *object_target;
   unsigned int imagebase_reloc;
@@ -159,7 +179,7 @@
   int bfd_arch;
   bfd_boolean underscored;
   autofilter_entry_type* autofilter_symbollist; 
-}
+  }
 pe_details_type;
 
 static autofilter_entry_type autofilter_symbollist_generic[] =
@@ -212,9 +232,15 @@
 static pe_details_type pe_detail_list[] =
 {
   {
+#ifndef pe_use_x86_64
     "pei-i386",
     "pe-i386",
     7 /* R_IMAGEBASE */,
+#else    
+	"pei-x86-64",
+    "pe-x86-64",
+    3 /* R_IMAGEBASE */,
+#endif
     PE_ARCH_i386,
     bfd_arch_i386,
     TRUE,
@@ -480,6 +506,7 @@
 	 it is too restrictive.  Instead we have
 	 a target specific list to use:  */
       afptr = pe_details->autofilter_symbollist; 
+
       while (afptr->name)
 	{
 	  if (strcmp (n, afptr->name) == 0)
@@ -590,7 +617,6 @@
 		  {
 		    char *name = xmalloc (strlen (sn) + 2 + 6);
 		    sprintf (name, "%s%s", U("_imp_"), sn);
-
 		    blhe = bfd_link_hash_lookup (info->hash, name,
 						 FALSE, FALSE, FALSE);
 		    free (name);
@@ -1235,6 +1261,12 @@
 		      reloc_data[total_relocs].type = 5;
 		      total_relocs++;
 		      break;
+#ifdef pe_use_x86_64
+			case BITS_AND_SHIFT (64, 0):
+				  reloc_data[total_relocs].type = 10;
+				  total_relocs++;
+				  break;
+#endif
 		    case BITS_AND_SHIFT (24, 2):
 		      /* FIXME: 0 is ARM_26D, it is defined in bfd/coff-arm.c
 			 Those ARM_xxx definitions should go in proper
@@ -1312,14 +1344,15 @@
 
       bfd_put_16 (abfd, (rva & 0xfff) + (reloc_data[i].type << 12),
 		  reloc_d + reloc_sz);
-      reloc_sz += 2;
 
+      reloc_sz += 2;
       if (reloc_data[i].type == 4)
 	{
 	  bfd_put_16 (abfd, reloc_data[i].extra, reloc_d + reloc_sz);
 	  reloc_sz += 2;
 	}
 
+
       page_count++;
     }
 
@@ -1630,10 +1663,12 @@
 
  	.section	.idata$5
  	.long		0
+ 	[ .long		0] for PE+
    fthunk:
 
  	.section	.idata$4
  	.long		0
+ 	[ .long		0] for PE+
    hname:                              */
 
 static bfd *
@@ -1679,21 +1714,21 @@
   quick_reloc (abfd, 16, BFD_RELOC_RVA, 1);
   save_relocs (id2);
 
-  bfd_set_section_size (abfd, id5, 4);
-  d5 = xmalloc (4);
+  bfd_set_section_size (abfd, id5, PE_IDATA5_SIZE);
+  d5 = xmalloc (PE_IDATA5_SIZE);
   id5->contents = d5;
-  memset (d5, 0, 4);
+  memset (d5, 0, PE_IDATA5_SIZE);
 
-  bfd_set_section_size (abfd, id4, 4);
-  d4 = xmalloc (4);
+  bfd_set_section_size (abfd, id4, PE_IDATA4_SIZE);
+  d4 = xmalloc (PE_IDATA4_SIZE);
   id4->contents = d4;
-  memset (d4, 0, 4);
+  memset (d4, 0, PE_IDATA4_SIZE);
 
   bfd_set_symtab (abfd, symtab, symptr);
 
   bfd_set_section_contents (abfd, id2, d2, 0, 20);
-  bfd_set_section_contents (abfd, id5, d5, 0, 4);
-  bfd_set_section_contents (abfd, id4, d4, 0, 4);
+  bfd_set_section_contents (abfd, id5, d5, 0, PE_IDATA5_SIZE);
+  bfd_set_section_contents (abfd, id4, d4, 0, PE_IDATA4_SIZE);
 
   bfd_make_readable (abfd);
   return abfd;
@@ -1701,8 +1736,10 @@
 
 /*	.section	.idata$4
  	.long		0
+  	[.long		0] for PE+
  	.section	.idata$5
  	.long		0
+ 	[.long		0] for PE+
  	.section	idata$7
  	.global		__my_dll_iname
   __my_dll_iname:
@@ -1735,15 +1772,15 @@
   id7 = quick_section (abfd, ".idata$7", SEC_HAS_CONTENTS, 2);
   quick_symbol (abfd, U (""), dll_symname, "_iname", id7, BSF_GLOBAL, 0);
 
-  bfd_set_section_size (abfd, id4, 4);
-  d4 = xmalloc (4);
+  bfd_set_section_size (abfd, id4, PE_IDATA4_SIZE);
+  d4 = xmalloc (PE_IDATA4_SIZE);
   id4->contents = d4;
-  memset (d4, 0, 4);
+  memset (d4, 0, PE_IDATA4_SIZE);
 
-  bfd_set_section_size (abfd, id5, 4);
-  d5 = xmalloc (4);
+  bfd_set_section_size (abfd, id5, PE_IDATA5_SIZE);
+  d5 = xmalloc (PE_IDATA5_SIZE);
   id5->contents = d5;
-  memset (d5, 0, 4);
+  memset (d5, 0, PE_IDATA5_SIZE);
 
   len = strlen (dll_filename) + 1;
   if (len & 1)
@@ -1755,8 +1792,8 @@
 
   bfd_set_symtab (abfd, symtab, symptr);
 
-  bfd_set_section_contents (abfd, id4, d4, 0, 4);
-  bfd_set_section_contents (abfd, id5, d5, 0, 4);
+  bfd_set_section_contents (abfd, id4, d4, 0, PE_IDATA4_SIZE);
+  bfd_set_section_contents (abfd, id5, d5, 0, PE_IDATA5_SIZE);
   bfd_set_section_contents (abfd, id7, d7, 0, len);
 
   bfd_make_readable (abfd);
@@ -1820,7 +1857,6 @@
   0,    0,    0,    0
 };
 
-
 static bfd *
 make_one (def_file_export *exp, bfd *parent)
 {
@@ -1943,16 +1979,16 @@
   quick_reloc (abfd, 0, BFD_RELOC_RVA, 5);
   save_relocs (id7);
 
-  bfd_set_section_size (abfd, id5, 4);
-  d5 = xmalloc (4);
+  bfd_set_section_size (abfd, id5, PE_IDATA5_SIZE);
+  d5 = xmalloc (PE_IDATA5_SIZE);
   id5->contents = d5;
-  memset (d5, 0, 4);
+  memset (d5, 0, PE_IDATA5_SIZE);
 
   if (exp->flag_noname)
     {
       d5[0] = exp->ordinal;
       d5[1] = exp->ordinal >> 8;
-      d5[3] = 0x80;
+      d5[PE_IDATA5_SIZE-1] = 0x80;
     }
   else
     {
@@ -1960,16 +1996,16 @@
       save_relocs (id5);
     }
 
-  bfd_set_section_size (abfd, id4, 4);
-  d4 = xmalloc (4);
+  bfd_set_section_size (abfd, id4, PE_IDATA4_SIZE);
+  d4 = xmalloc (PE_IDATA4_SIZE);
   id4->contents = d4;
-  memset (d4, 0, 4);
+  memset (d4, 0, PE_IDATA4_SIZE);
 
   if (exp->flag_noname)
     {
       d4[0] = exp->ordinal;
       d4[1] = exp->ordinal >> 8;
-      d4[3] = 0x80;
+      d4[PE_IDATA4_SIZE-1] = 0x80;
     }
   else
     {
@@ -2000,8 +2036,8 @@
 
   bfd_set_section_contents (abfd, tx, td, 0, jmp_byte_count);
   bfd_set_section_contents (abfd, id7, d7, 0, 4);
-  bfd_set_section_contents (abfd, id5, d5, 0, 4);
-  bfd_set_section_contents (abfd, id4, d4, 0, 4);
+  bfd_set_section_contents (abfd, id5, d5, 0, PE_IDATA5_SIZE);
+  bfd_set_section_contents (abfd, id4, d4, 0, PE_IDATA4_SIZE);
   if (!exp->flag_noname)
     bfd_set_section_contents (abfd, id6, d6, 0, len);
 
@@ -2035,16 +2071,16 @@
   quick_symbol (abfd, U ("_nm_thnk_"), import, "", id4, BSF_GLOBAL, 0);
   quick_symbol (abfd, U ("_nm_"), import, "", UNDSEC, BSF_GLOBAL, 0);
 
-  bfd_set_section_size (abfd, id4, 8);
-  d4 = xmalloc (4);
+  bfd_set_section_size (abfd, id4, PE_IDATA4_SIZE);
+  d4 = xmalloc (PE_IDATA4_SIZE);
   id4->contents = d4;
-  memset (d4, 0, 8);
+  memset (d4, 0, PE_IDATA4_SIZE);
   quick_reloc (abfd, 0, BFD_RELOC_RVA, 2);
   save_relocs (id4);
 
   bfd_set_symtab (abfd, symtab, symptr);
 
-  bfd_set_section_contents (abfd, id4, d4, 0, 8);
+  bfd_set_section_contents (abfd, id4, d4, 0, PE_IDATA4_SIZE);
 
   bfd_make_readable (abfd);
   return abfd;
@@ -2557,14 +2593,21 @@
 
   /* Get pe_header, optional header and numbers of export entries.  */
   pe_header_offset = pe_get32 (dll, 0x3c);
-  opthdr_ofs = pe_header_offset + 4 + 20;
+  opthdr_ofs = pe_header_offset + 4 + 20; // Magic of opt header
+#ifndef pe_use_x86_64
   num_entries = pe_get32 (dll, opthdr_ofs + 92);
-
+#else
+  num_entries = pe_get32 (dll, opthdr_ofs + 92 +4*4); //  &NumberOfRvaAndSizes
+#endif
   if (num_entries < 1) /* No exports.  */
     return FALSE;
-
+#ifndef pe_use_x86_64
   export_rva = pe_get32 (dll, opthdr_ofs + 96);
   export_size = pe_get32 (dll, opthdr_ofs + 100);
+#else
+  export_rva = pe_get32 (dll, opthdr_ofs + 96+4*4);
+  export_size = pe_get32 (dll, opthdr_ofs + 100+4*4);
+#endif
   nsections = pe_get16 (dll, pe_header_offset + 4 + 2);
   secptr = (pe_header_offset + 4 + 20 +
 	    pe_get16 (dll, pe_header_offset + 4 + 16));
diff -rNbu binutils_060913_org/ld/pep-dll.c binutils_060913/ld/pep-dll.c
--- binutils_060913_org/ld/pep-dll.c	1970-01-01 01:00:00.000000000 +0100
+++ binutils_060913/ld/pep-dll.c	2006-09-11 18:04:06.000000000 +0200
@@ -0,0 +1,58 @@
+/* Routines to help build PEPI-format DLLs (Win64 etc)
+   Copyright 1995, 1996, 1999, 2001, 2002, 2004 Free Software Foundation, Inc.
+
+   This file is part of BFD, the Binary File Descriptor library.
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston, MA 02110-1301, USA.
+   
+   Written by Kai Tietz, OneVision Software GmbH&CoKg.
+*/
+
+#define COFF_IMAGE_WITH_PE
+#define COFF_WITH_PE
+#define COFF_WITH_pex64
+
+/* Local defined globals */
+#define pe_def_file	pep_def_file
+#define pe_details	pep_details
+#define pe_dll_compat_implib pep_dll_compat_implib
+#define pe_dll_extra_pe_debug pep_dll_extra_pe_debug
+#define pe_dll_export_everything pep_dll_export_everything
+#define pe_dll_do_default_excludes pep_dll_do_default_excludes
+#define pe_dll_kill_ats pep_dll_kill_ats
+#define pe_dll_stdcall_aliases pep_dll_stdcall_aliases
+#define pe_dll_warn_dup_exports pep_dll_warn_dup_exports
+
+/* external globals */
+#define pe_data_import_dll pep_data_import_dll
+
+/* Unique global name for functions to avoid double defined symbols */
+#define pe_create_import_fixup pep_create_import_fixup
+#define pe_dll_generate_def_file pep_dll_generate_def_file
+#define pe_process_import_defs pep_process_import_defs
+#define pe_dll_id_target pep_dll_id_target
+#define pe_implied_import_dll pep_implied_import_dll
+#define pe_dll_build_sections pep_dll_build_sections
+#define pe_exe_build_sections pep_exe_build_sections
+#define pe_dll_fill_sections pep_dll_fill_sections
+#define pe_exe_fill_sections pep_exe_fill_sections
+#define pe_dll_generate_implib pep_dll_generate_implib
+#define pe_dll_add_excludes pep_dll_add_excludes
+#define pe_walk_relocs_of_symbol pep_walk_relocs_of_symbol
+
+// Uses x86_64 PE+
+#define pe_use_x86_64
+
+#include "pe-dll.c"
diff -rNbu binutils_060913_org/ld/pep-dll.h binutils_060913/ld/pep-dll.h
--- binutils_060913_org/ld/pep-dll.h	1970-01-01 01:00:00.000000000 +0100
+++ binutils_060913/ld/pep-dll.h	2006-08-17 09:13:36.000000000 +0200
@@ -0,0 +1,64 @@
+/* pep-dll.h: Header file for routines used to build Windows DLLs.
+   Copyright 1995, 1996, 1999, 2001, 2002, 2004 Free Software Foundation, Inc.
+
+   This file is part of BFD, the Binary File Descriptor library.
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston, MA 02110-1301, USA.
+   
+   Written by Kai Tietz, OneVision Software GmbH&CoKg.
+*/
+
+#ifndef PEP_DLL_H
+#define PEP_DLL_H
+
+#include "bfd.h"
+#include "sysdep.h"
+#include "bfdlink.h"
+#include "deffile.h"
+
+extern def_file *pep_def_file;
+extern int pep_dll_export_everything;
+extern int pep_dll_do_default_excludes;
+extern int pep_dll_kill_ats;
+extern int pep_dll_stdcall_aliases;
+extern int pep_dll_warn_dup_exports;
+extern int pep_dll_compat_implib;
+extern int pep_dll_extra_pe_debug;
+
+extern void pep_dll_id_target
+  (const char *);
+extern void pep_dll_add_excludes
+  (const char *, const int);
+extern void pep_dll_generate_def_file
+  (const char *);
+extern void pep_dll_generate_implib
+  (def_file *, const char *);
+extern void pep_process_import_defs
+  (bfd *, struct bfd_link_info *);
+extern bfd_boolean pep_implied_import_dll
+  (const char *);
+extern void pep_dll_build_sections
+  (bfd *, struct bfd_link_info *);
+extern void pep_exe_build_sections
+  (bfd *, struct bfd_link_info *);
+extern void pep_dll_fill_sections
+  (bfd *, struct bfd_link_info *);
+extern void pep_exe_fill_sections
+  (bfd *, struct bfd_link_info *);
+extern void pep_walk_relocs_of_symbol
+  (struct bfd_link_info *, const char *, int (*) (arelent *, asection *));
+extern void pep_create_import_fixup
+  (arelent * rel, asection *, int);
+#endif /* PE_DLL_H */
diff -rNbu binutils_060913_org/ld/scripttempl/pep.sc binutils_060913/ld/scripttempl/pep.sc
--- binutils_060913_org/ld/scripttempl/pep.sc	1970-01-01 01:00:00.000000000 +0100
+++ binutils_060913/ld/scripttempl/pep.sc	2006-07-28 14:12:24.000000000 +0200
@@ -0,0 +1,272 @@
+# Linker script for PE.
+
+if test -z "${RELOCATEABLE_OUTPUT_FORMAT}"; then
+  RELOCATEABLE_OUTPUT_FORMAT=${OUTPUT_FORMAT}
+fi
+
+# We can't easily and portably get an unquoted $ in a shell
+# substitution, so we do this instead.
+# Sorting of the .foo$* sections is required by the definition of
+# grouped sections in PE.
+# Sorting of the file names in R_IDATA is required by the
+# current implementation of dlltool (this could probably be changed to
+# use grouped sections instead).
+if test "${RELOCATING}"; then
+  R_TEXT='*(SORT(.text$*))'
+  R_DATA='*(SORT(.data$*))'
+  R_RDATA='*(SORT(.rdata$*))'
+  R_IDATA='
+    SORT(*)(.idata$2)
+    SORT(*)(.idata$3)
+    /* These zeroes mark the end of the import list.  */
+    LONG (0); LONG (0); LONG (0); LONG (0); LONG (0);
+    SORT(*)(.idata$4)
+    SORT(*)(.idata$5)
+    SORT(*)(.idata$6)
+    SORT(*)(.idata$7)'
+  R_CRT_XC='*(SORT(.CRT$XC*))  /* C initialization */'
+  R_CRT_XI='*(SORT(.CRT$XI*))  /* C++ initialization */'
+  R_CRT_XL='*(SORT(.CRT$XL*))  /* TLS callbacks */'
+  R_CRT_XP='*(SORT(.CRT$XP*))  /* Pre-termination */'
+  R_CRT_XT='*(SORT(.CRT$XT*))  /* Termination */'
+  R_TLS='
+    *(.tls)
+    *(.tls$)
+    *(SORT(.tls$*))'
+  R_RSRC='*(SORT(.rsrc$*))'
+else
+  R_TEXT=
+  R_DATA=
+  R_RDATA=
+  R_IDATA=
+  R_CRT=
+  R_RSRC=
+fi
+
+cat <<EOF
+${RELOCATING+OUTPUT_FORMAT(${OUTPUT_FORMAT})}
+${RELOCATING-OUTPUT_FORMAT(${RELOCATEABLE_OUTPUT_FORMAT})}
+${OUTPUT_ARCH+OUTPUT_ARCH(${OUTPUT_ARCH})}
+
+${LIB_SEARCH_DIRS}
+
+SECTIONS
+{
+  ${RELOCATING+/* Make the virtual address and file offset synced if the alignment is}
+  ${RELOCATING+   lower than the target page size. */}
+  ${RELOCATING+. = SIZEOF_HEADERS;}
+  ${RELOCATING+. = ALIGN(__section_alignment__);}
+  .text ${RELOCATING+ __image_base__ + ( __section_alignment__ < ${TARGET_PAGE_SIZE} ? . : __section_alignment__ )} : 
+  {
+    ${RELOCATING+ *(.init)}
+    *(.text)
+    ${R_TEXT}
+    *(.glue_7t)
+    *(.glue_7)
+    ${CONSTRUCTING+ ___CTOR_LIST__ = .; __CTOR_LIST__ = . ; 
+			LONG (-1);*(.ctors); *(.ctor); *(SORT(.ctors.*));  LONG (0); }
+    ${CONSTRUCTING+ ___DTOR_LIST__ = .; __DTOR_LIST__ = . ; 
+			LONG (-1); *(.dtors); *(.dtor); *(SORT(.dtors.*));  LONG (0); }
+    ${RELOCATING+ *(.fini)}
+    /* ??? Why is .gcc_exc here?  */
+    ${RELOCATING+ *(.gcc_exc)}
+    ${RELOCATING+PROVIDE (etext = .);}
+    *(.gcc_except_table)
+  }
+
+  /* The Cygwin32 library uses a section to avoid copying certain data
+     on fork.  This used to be named ".data$nocopy".  The linker used
+     to include this between __data_start__ and __data_end__, but that
+     breaks building the cygwin32 dll.  Instead, we name the section
+     ".data_cygwin_nocopy" and explictly include it after __data_end__. */
+
+  .data ${RELOCATING+BLOCK(__section_alignment__)} : 
+  {
+    ${RELOCATING+__data_start__ = . ;}
+    *(.data)
+    *(.data2)
+    ${R_DATA}
+    *(.jcr)
+    ${RELOCATING+__data_end__ = . ;}
+    ${RELOCATING+*(.data_cygwin_nocopy)}
+  }
+
+  .rdata ${RELOCATING+BLOCK(__section_alignment__)} :
+  {
+    *(.rdata)
+    ${R_RDATA}
+    *(.eh_frame)
+    ${RELOCATING+___RUNTIME_PSEUDO_RELOC_LIST__ = .;}
+    ${RELOCATING+__RUNTIME_PSEUDO_RELOC_LIST__ = .;}
+    *(.rdata_runtime_pseudo_reloc)
+    ${RELOCATING+___RUNTIME_PSEUDO_RELOC_LIST_END__ = .;}
+    ${RELOCATING+__RUNTIME_PSEUDO_RELOC_LIST_END__ = .;}
+  }
+
+  .pdata ${RELOCATING+BLOCK(__section_alignment__)} :
+  {
+    *(.pdata)
+  }
+
+  .bss ${RELOCATING+BLOCK(__section_alignment__)} :
+  {
+    ${RELOCATING+__bss_start__ = . ;}
+    *(.bss)
+    *(COMMON)
+    ${RELOCATING+__bss_end__ = . ;}
+  }
+
+  .edata ${RELOCATING+BLOCK(__section_alignment__)} :
+  {
+    *(.edata)
+  }
+
+  /DISCARD/ :
+  {
+    *(.debug\$S)
+    *(.debug\$T)
+    *(.debug\$F)
+    *(.drectve)
+  }
+
+  .idata ${RELOCATING+BLOCK(__section_alignment__)} :
+  {
+    /* This cannot currently be handled with grouped sections.
+	See pep.em:sort_sections.  */
+    ${R_IDATA}
+  }
+  .CRT ${RELOCATING+BLOCK(__section_alignment__)} :
+  { 					
+    ${RELOCATING+___crt_xc_start__ = . ;}
+    ${R_CRT_XC}
+    ${RELOCATING+___crt_xc_end__ = . ;}
+    ${RELOCATING+___crt_xi_start__ = . ;}
+    ${R_CRT_XI}
+    ${RELOCATING+___crt_xi_end__ = . ;}
+    ${RELOCATING+___crt_xl_start__ = . ;}
+    ${R_CRT_XL}
+    /* ___crt_xl_end__ is defined in the TLS Directory support code */
+    ${RELOCATING+___crt_xp_start__ = . ;}
+    ${R_CRT_XP}
+    ${RELOCATING+___crt_xp_end__ = . ;}
+    ${RELOCATING+___crt_xt_start__ = . ;}
+    ${R_CRT_XT}
+    ${RELOCATING+___crt_xt_end__ = . ;}
+  }
+
+  .tls ${RELOCATING+BLOCK(__section_alignment__)} :
+  { 					
+    ${RELOCATING+___tls_start__ = . ;}
+    ${R_TLS}
+    ${RELOCATING+___tls_end__ = . ;}
+  }
+
+  .endjunk ${RELOCATING+BLOCK(__section_alignment__)} :
+  {
+    /* end is deprecated, don't use it */
+    ${RELOCATING+PROVIDE (end = .);}
+    ${RELOCATING+PROVIDE ( _end = .);}
+    ${RELOCATING+ __end__ = .;}
+  }
+
+  .rsrc ${RELOCATING+BLOCK(__section_alignment__)} :
+  { 					
+    *(.rsrc)
+    ${R_RSRC}
+  }
+
+  .reloc ${RELOCATING+BLOCK(__section_alignment__)} :
+  { 					
+    *(.reloc)
+  }
+
+  .stab ${RELOCATING+BLOCK(__section_alignment__)} ${RELOCATING+(NOLOAD)} :
+  {
+    *(.stab)
+  }
+
+  .stabstr ${RELOCATING+BLOCK(__section_alignment__)} ${RELOCATING+(NOLOAD)} :
+  {
+    *(.stabstr)
+  }
+
+  /* DWARF debug sections.
+     Symbols in the DWARF debugging sections are relative to the beginning
+     of the section.  Unlike other targets that fake this by putting the
+     section VMA at 0, the PE format will not allow it.  */
+     
+  /* DWARF 1.1 and DWARF 2.  */
+  .debug_aranges ${RELOCATING+BLOCK(__section_alignment__)} ${RELOCATING+(NOLOAD)} :
+  {
+    *(.debug_aranges)
+  }
+
+  .debug_pubnames ${RELOCATING+BLOCK(__section_alignment__)} ${RELOCATING+(NOLOAD)} :
+  {
+    *(.debug_pubnames)
+  }
+
+  /* DWARF 2.  */
+  .debug_info ${RELOCATING+BLOCK(__section_alignment__)} ${RELOCATING+(NOLOAD)} :
+  {
+    *(.debug_info) *(.gnu.linkonce.wi.*)
+  }
+
+  .debug_abbrev ${RELOCATING+BLOCK(__section_alignment__)} ${RELOCATING+(NOLOAD)} :
+  {
+    *(.debug_abbrev)
+  }
+
+  .debug_line ${RELOCATING+BLOCK(__section_alignment__)} ${RELOCATING+(NOLOAD)} :
+  {
+    *(.debug_line)
+  }
+
+  .debug_frame ${RELOCATING+BLOCK(__section_alignment__)} ${RELOCATING+(NOLOAD)} :
+  {
+    *(.debug_frame)
+  }
+
+  .debug_str ${RELOCATING+BLOCK(__section_alignment__)} ${RELOCATING+(NOLOAD)} :
+  {
+    *(.debug_str)
+  }
+
+  .debug_loc ${RELOCATING+BLOCK(__section_alignment__)} ${RELOCATING+(NOLOAD)} :
+  {
+    *(.debug_loc)
+  }
+
+  .debug_macinfo ${RELOCATING+BLOCK(__section_alignment__)} ${RELOCATING+(NOLOAD)} :
+  {
+    *(.debug_macinfo)
+  }
+
+  /* SGI/MIPS DWARF 2 extensions.  */
+  .debug_weaknames ${RELOCATING+BLOCK(__section_alignment__)} ${RELOCATING+(NOLOAD)} :
+  {
+    *(.debug_weaknames)
+  }
+
+  .debug_funcnames ${RELOCATING+BLOCK(__section_alignment__)} ${RELOCATING+(NOLOAD)} :
+  {
+    *(.debug_funcnames)
+  }
+
+  .debug_typenames ${RELOCATING+BLOCK(__section_alignment__)} ${RELOCATING+(NOLOAD)} :
+  {
+    *(.debug_typenames)
+  }
+
+  .debug_varnames ${RELOCATING+BLOCK(__section_alignment__)} ${RELOCATING+(NOLOAD)} :
+  {
+    *(.debug_varnames)
+  }
+
+  /* DWARF 3.  */
+  .debug_ranges ${RELOCATING+BLOCK(__section_alignment__)} ${RELOCATING+(NOLOAD)} :
+  {
+    *(.debug_ranges)
+  }
+}
+EOF
diff -rNbu binutils_060913_org/ld/testsuite/ChangeLog binutils_060913/ld/testsuite/ChangeLog
--- binutils_060913_org/ld/testsuite/ChangeLog	2006-09-13 00:10:31.000000000 +0200
+++ binutils_060913/ld/testsuite/ChangeLog	2006-09-13 11:12:23.000000000 +0200
@@ -1,3 +1,15 @@
+2006-09-13	Kai Tietz	<Kai.Tietz@onevision.com>
+
+	* bootstrap/bootstrap.exp:		Enable target test
+	* ld-fastcall/fastcall.exp:		Enable target test
+	* ld-scripts/align.exp:		Enable target test
+	* ld-scripts/align2a.d:		Enable target test
+	* ld-scripts/defined.exp:		Enable target test
+	* ld-scripts/provide.exp:		Enable target test
+	* ld-scripts/script.exp:		Enable target test
+	* ld-scripts/weak.exp:		Enable target test
+	* lib/ld-lib.exp:		Detect target as pecoff file format
+
 2006-09-12  H.J. Lu  <hongjiu.lu@intel.com>
 
 	PR ld/3197
diff -rNbu binutils_060913_org/ld/testsuite/ld-bootstrap/bootstrap.exp binutils_060913/ld/testsuite/ld-bootstrap/bootstrap.exp
--- binutils_060913_org/ld/testsuite/ld-bootstrap/bootstrap.exp	2005-11-15 09:32:01.000000000 +0100
+++ binutils_060913/ld/testsuite/ld-bootstrap/bootstrap.exp	2006-09-11 14:54:48.000000000 +0200
@@ -140,7 +140,7 @@
 	|| [istarget "*-*-wince"]
 	|| [istarget "*-*-cygwin*"]
 	|| [istarget "*-*-winnt*"]
-	|| [istarget "*-*-mingw32*"]
+	|| [istarget "*-*-mingw*"]
 	|| [istarget "*-*-interix*"]
 	|| [istarget "*-*-beospe*"]
 	|| [istarget "*-*-netbsdpe*"]} {
diff -rNbu binutils_060913_org/ld/testsuite/ld-fastcall/fastcall.exp binutils_060913/ld/testsuite/ld-fastcall/fastcall.exp
--- binutils_060913_org/ld/testsuite/ld-fastcall/fastcall.exp	2005-05-12 09:32:06.000000000 +0200
+++ binutils_060913/ld/testsuite/ld-fastcall/fastcall.exp	2006-09-11 14:55:40.000000000 +0200
@@ -17,13 +17,13 @@
 
 set testname "ld (fastcall symbols)"
 
-if {![istarget "i*86-*-*"]} {
+if {![istarget "i*86-*-*"] && ![istarget "x86_64-*-mingw64*"] } {
     return
 }
 
 if {  !([istarget "i*86-*-*pe*"] && ![istarget "i*86-*-opensd*"]) \
     && ![istarget "i*86-*-cygwin*"] \
-    && ![istarget "i*86-*-mingw32*"] } {
+    && ![istarget "i*86-*-mingw*"] } {
     return
 }
 
diff -rNbu binutils_060913_org/ld/testsuite/ld-scripts/align.exp binutils_060913/ld/testsuite/ld-scripts/align.exp
--- binutils_060913_org/ld/testsuite/ld-scripts/align.exp	2005-10-25 19:40:12.000000000 +0200
+++ binutils_060913/ld/testsuite/ld-scripts/align.exp	2006-09-11 14:57:56.000000000 +0200
@@ -30,12 +30,19 @@
 }
 
 # Doesn't work on PECOFF, appears to be a genuine bug
-if [is_pecoff_format] {
+# mingw64 targets need to set the image base to 0 to avoid auto image-basing.
+global LDFLAGS
+set saved_LDFLAGS "$LDFLAGS"
+if [istarget "*-*-mingw64*"] then {
+  set LDFLAGS "$LDFLAGS --image-base 0"
+} else {
+  if [is_pecoff_format] {
   global target_triplet
   setup_xfail $target_triplet
+  }
 }
 
-if ![ld_simple_link $ld tmpdir/align "-T $srcdir/$subdir/align.t tmpdir/align.o"] {
+if ![ld_simple_link $ld tmpdir/align "$LDFLAGS -T $srcdir/$subdir/align.t tmpdir/align.o"] {
     fail $testname
 } else {
     pass $testname
@@ -50,3 +57,4 @@
     run_dump_test align2b
 }
 run_dump_test align2c
+set LDFLAGS "$saved_LDFLAGS"
diff -rNbu binutils_060913_org/ld/testsuite/ld-scripts/align2a.d binutils_060913/ld/testsuite/ld-scripts/align2a.d
--- binutils_060913_org/ld/testsuite/ld-scripts/align2a.d	2005-02-21 09:18:49.000000000 +0100
+++ binutils_060913/ld/testsuite/ld-scripts/align2a.d	2006-09-06 15:34:34.000000000 +0200
@@ -1,12 +1,12 @@
-# ld: --defsym data_align=16 -T align2.t
-# objdump: --section-headers
+#ld: --defsym data_align=16 -T align2.t
+#objdump: --section-headers
 
 [^:]+: +file format.*
 
 Sections:
 Idx +Name +Size +VMA +LMA +File +off +Algn
- +0 +\.text +[^ ]* +0+ +0+ .*
- +CONTENTS, +ALLOC, +LOAD,.* CODE
- +1 +\.data +[^ ]* +0+10 +0+10 .*
- +CONTENTS, +ALLOC, +LOAD, +DATA
+[	 ]+0 +\.text +[^ ]* +0+ +0+ .*
+[	 ]+CONTENTS, +ALLOC, +LOAD,.* CODE
+[	 ]+1 +\.data +[^ ]* +0+10 +0+10 .*
+[	 ]+CONTENTS, +ALLOC, +LOAD, +DATA
 #pass
diff -rNbu binutils_060913_org/ld/testsuite/ld-scripts/defined.exp binutils_060913/ld/testsuite/ld-scripts/defined.exp
--- binutils_060913_org/ld/testsuite/ld-scripts/defined.exp	2005-05-12 09:32:08.000000000 +0200
+++ binutils_060913/ld/testsuite/ld-scripts/defined.exp	2006-09-06 17:02:32.000000000 +0200
@@ -20,12 +20,19 @@
 set testname "DEFINED"
 set prms_id 5699
 
+global LDFLAGS
+set saved_LDFLAGS "$LDFLAGS"
+if [istarget "*-*-mingw64*"] then {
+  set LDFLAGS "$LDFLAGS --image-base 0"
+}
+
 if ![ld_assemble $as $srcdir/$subdir/defined.s tmpdir/def.o] {
     unresolved $testname
+    set LDFLAGS "$saved_LDFLAGS"
     return
 }
 
-if ![ld_simple_link $ld tmpdir/def "-T $srcdir/$subdir/defined.t tmpdir/def.o"] {
+if ![ld_simple_link $ld tmpdir/def "$LDFLAGS -T $srcdir/$subdir/defined.t tmpdir/def.o"] {
     fail $testname
 } else {
     if ![ld_nm $nm "" tmpdir/def] {
@@ -57,3 +64,4 @@
 set prms_id 0
 run_dump_test "defined2"
 run_dump_test "defined3"
+set LDFLAGS "$saved_LDFLAGS"
diff -rNbu binutils_060913_org/ld/testsuite/ld-scripts/provide.exp binutils_060913/ld/testsuite/ld-scripts/provide.exp
--- binutils_060913_org/ld/testsuite/ld-scripts/provide.exp	2005-06-01 06:04:19.000000000 +0200
+++ binutils_060913/ld/testsuite/ld-scripts/provide.exp	2006-09-06 17:04:32.000000000 +0200
@@ -29,7 +29,15 @@
     return
 }
 
+global LDFLAGS
+set saved_LDFLAGS "$LDFLAGS"
+if [istarget "*-*-mingw64*"] then {
+  set LDFLAGS "$LDFLAGS --image-base 0"
+}
+
+
 run_dump_test provide-1
 run_dump_test provide-2
 setup_xfail *-*-*
 run_dump_test provide-3
+set LDFLAGS "$saved_LDFLAGS"
diff -rNbu binutils_060913_org/ld/testsuite/ld-scripts/script.exp binutils_060913/ld/testsuite/ld-scripts/script.exp
--- binutils_060913_org/ld/testsuite/ld-scripts/script.exp	2005-05-12 09:32:08.000000000 +0200
+++ binutils_060913/ld/testsuite/ld-scripts/script.exp	2006-09-11 15:00:32.000000000 +0200
@@ -95,7 +95,7 @@
 set flags ""
 if {[istarget "*-*-pe*"] \
     || [istarget "*-*-cygwin*"] \
-    || [istarget "*-*-mingw32*"] \
+    || [istarget "*-*-mingw*"] \
     || [istarget "*-*-winnt*"] \
     || [istarget "*-*-nt"] \
     || [istarget "*-*-interix*"] } then {
diff -rNbu binutils_060913_org/ld/testsuite/ld-scripts/weak.exp binutils_060913/ld/testsuite/ld-scripts/weak.exp
--- binutils_060913_org/ld/testsuite/ld-scripts/weak.exp	2005-08-18 09:51:07.000000000 +0200
+++ binutils_060913/ld/testsuite/ld-scripts/weak.exp	2006-09-06 17:33:38.000000000 +0200
@@ -29,11 +29,11 @@
 # Weak symbols are broken for non-i386 PE targets.
 if {! [istarget i?86-*-*]} {
     setup_xfail *-*-pe*
+    setup_xfail *-*-mingw64*
 }
 
 # hppa64 and or32 are incredibly broken
 setup_xfail hppa64-*-* or32-*-*
-
 if {! [ld_assemble $as $srcdir/$subdir/weak1.s tmpdir/weak1.o]
     || ! [ld_assemble $as $srcdir/$subdir/weak2.s tmpdir/weak2.o]} then {
     # It's OK if .weak doesn't work on this target.
@@ -41,6 +41,12 @@
     return
 }
 
+global LDFLAGS
+set saved_LDFLAGS "$LDFLAGS"
+if [istarget "*-*-mingw64*"] then {
+  set LDFLAGS "$LDFLAGS --image-base 0"
+}
+
 set weak_regexp_big \
 ".*Contents of section .text:.*1000 00001008 0000200c 12121212 34343434.*Contents of section .data:.*2000 00001008 0000200c 56565656 78787878.*"
 
@@ -67,3 +73,4 @@
 	fail $testname
     }
 }
+set LDFLAGS "$saved_LDFLAGS"
diff -rNbu binutils_060913_org/ld/testsuite/lib/ld-lib.exp binutils_060913/ld/testsuite/lib/ld-lib.exp
--- binutils_060913_org/ld/testsuite/lib/ld-lib.exp	2006-09-07 19:16:34.000000000 +0200
+++ binutils_060913/ld/testsuite/lib/ld-lib.exp	2006-09-11 15:02:02.000000000 +0200
@@ -434,7 +434,7 @@
 # True if the object format is known to be PE COFF.
 #
 proc is_pecoff_format {} {
-    if { ![istarget *-*-mingw32*] \
+    if { ![istarget *-*-mingw*] \
 	 && ![istarget *-*-cygwin*] \
 	 && ![istarget *-*-pe*] } {
 	return 0
